// Copyright 2020 FoxyUtils ehf. All rights reserved.
//
// DO NOT EDIT: generated by unioffice ECMA-376 generator
//
// Use of this source code is governed by the terms of the Affero GNU General
// Public License version 3.0 as published by the Free Software Foundation and
// appearing in the file LICENSE included in the packaging of this file. A
// commercial license can be purchased via https://unidoc.io website.

package sml

import (
	"encoding/xml"

	"github.com/unidoc/unioffice"
)

type CT_Authors struct {
	// Author
	Author []string
}

func NewCT_Authors() *CT_Authors {
	ret := &CT_Authors{}
	return ret
}

func (m *CT_Authors) MarshalXML(e *xml.Encoder, start xml.StartElement) error {
	e.EncodeToken(start)
	if m.Author != nil {
		seauthor := xml.StartElement{Name: xml.Name{Local: "ma:author"}}
		for _, c := range m.Author {
			e.EncodeElement(c, seauthor)
		}
	}
	e.EncodeToken(xml.EndElement{Name: start.Name})
	return nil
}

func (m *CT_Authors) UnmarshalXML(d *xml.Decoder, start xml.StartElement) error {
	// initialize to default
lCT_Authors:
	for {
		tok, err := d.Token()
		if err != nil {
			return err
		}
		switch el := tok.(type) {
		case xml.StartElement:
			switch el.Name {
			case xml.Name{Space: "http://schemas.openxmlformats.org/spreadsheetml/2006/main", Local: "author"},
				xml.Name{Space: "http://purl.oclc.org/ooxml/spreadsheetml/main", Local: "author"}:
				var tmp string
				if err := d.DecodeElement(&tmp, &el); err != nil {
					return err
				}
				m.Author = append(m.Author, tmp)
			default:
				unioffice.Log("skipping unsupported element on CT_Authors %v", el.Name)
				if err := d.Skip(); err != nil {
					return err
				}
			}
		case xml.EndElement:
			break lCT_Authors
		case xml.CharData:
		}
	}
	return nil
}

// Validate validates the CT_Authors and its children
func (m *CT_Authors) Validate() error {
	return m.ValidateWithPath("CT_Authors")
}

// ValidateWithPath validates the CT_Authors and its children, prefixing error messages with path
func (m *CT_Authors) ValidateWithPath(path string) error {
	return nil
}
